<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class Cnc03000Token extends \Teknisa\CNC\Controllers\TeknisaCrud {
    
    protected $TokenService;
    protected $salesMessage;
    protected $dataSourceNameArray = array (
        'TOKEN'                  => 'cnc03000_cadastro_token'
    );
    protected $parameterBagColumnsArray = array (
        'TOKEN'                =>  array('NRORG')
    );
    
    public function __construct($dataSourceManager, $parameterBag) {
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function find (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['TOKEN'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['TOKEN'];
        parent::find($request, $response);
    }
    
    public function save (DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName = $this->dataSourceNameArray['TOKEN'];
            $this->parameterBagColumns = $this->parameterBagColumnsArray['TOKEN'];
            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function deleteRows (DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName = $this->dataSourceNameArray['TOKEN'];
            $this->parameterBagColumns = $this->parameterBagColumnsArray['TOKEN'];
            parent::delete($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}