<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc00100CriterioFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getStandarts($params){
        $sql = "SELECT V.NRADQUIRENTE, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL,
                V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getEstabelecStandarts($params){
        $sql = "SELECT V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0,  V.NRDIASTOL) NRDIASTOL,
        V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO,  
        DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
        V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.NRORG, V.IDDTVENCIMENTO
            FROM VALIDACAOADQEST V 
                JOIN ADQUIRENTE ADQ 
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE 
                WHERE V.NRADQUIRENTE = :NRADQUIRENTE 
                    AND V.NRESTABELEC = :NRESTABELEC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandard($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, V.NRVALIDACAOADQ, 
                V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRVALIDACAOADQ = :NRVALIDACAOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getEstabelecStandard($params){
        $sql = "SELECT V.NRORDEM, V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL,
                V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRESTABELEC = :NRESTABELEC
                    AND V.NRVALIDACAOADQEST = :NRVALIDACAOADQEST";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsIns($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                      AND V.NRORDEM = :NRORDEM";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsUpdt($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                      AND V.NRORDEM = :NRORDEM
                      AND V.NRVALIDACAOADQ <> :NRVALIDACAOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandarts($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                      AND V.NRORDEM IS NOT NULL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsEstIns($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRESTABELEC = :NRESTABELEC
                      AND V.NRORDEM = :NRORDEM";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function validateOrderStandartsEstUpdt($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRESTABELEC = :NRESTABELEC
                      AND V.NRORDEM = :NRORDEM
                      AND V.NRVALIDACAOADQEST <> :NRVALIDACAOADQEST";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsEst($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRESTABELEC = :NRESTABELEC
                      AND V.NRORDEM IS NOT NULL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsCad($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQ, V.NRADQUIRENTE, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, V.IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQ V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                      AND V.NRORDEM = :NRORDEM";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getOrderStandartsEstCad($params){
        $sql = "SELECT V.NRORDEM, DECODE(V.NRDIASTOL, NULL , 0, V.NRDIASTOL) NRDIASTOL, 
                V.NRVALIDACAOADQEST, V.NRADQUIRENTE, V.NRESTABELEC, V.IDNSU, V.IDNSUPOS, V.IDTOLERANCIA, V.IDAUTORIZACAO, 
                DECODE(V.IDBANCO||V.IDAGENCIA||V.IDCONTCORR, 'SSS', 'S', 'N') DADOSBANCO, 
                V.IDPRODUTOADQ, V.IDADQUIRENTE, V.IDBANDEIRA, V.IDEXIGEVRIGUAL, IDAJUSTEAUT, V.IDDTVENCIMENTO
                 FROM VALIDACAOADQEST V JOIN ADQUIRENTE ADQ
                  ON V.NRADQUIRENTE = ADQ.NRADQUIRENTE
                 WHERE V.NRADQUIRENTE = :NRADQUIRENTE
                    AND V.NRESTABELEC = :NRESTABELEC
                      AND V.NRORDEM = :NRORDEM";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateOrderStandarts($params){
        $sql = "UPDATE VALIDACAOADQ
                    SET IDNSU       = :IDNSU,
                    IDNSUPOS        = :IDNSUPOS,
                    IDTOLERANCIA    = :IDTOLERANCIA,
                    IDBANCO         = :IDBANCO,
                    IDAGENCIA       = :IDAGENCIA,
                    IDCONTCORR      = :IDCONTCORR,
                    IDPRODUTOADQ    = :IDPRODUTOADQ,
                    IDADQUIRENTE    = :IDADQUIRENTE,
                    IDBANDEIRA      = :IDBANDEIRA,
                    IDAJUSTEAUT     = :IDAJUSTEAUT,
                    NRORDEM         = :NRORDEM,
                    NRDIASTOL       = :NRDIASTOL,
                    IDDTVENCIMENTO  = :IDDTVENCIMENTO
                WHERE NRADQUIRENTE  = :NRADQUIRENTE
                  AND NRVALIDACAOADQ = :NRVALIDACAOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateOrderStandartsEst($params){
        $sql = "UPDATE VALIDACAOADQEST
                    SET IDNSU       = :IDNSU,
                    IDNSUPOS        = :IDNSUPOS,
                    IDTOLERANCIA    = :IDTOLERANCIA,
                    IDBANCO         = :IDBANCO,
                    IDAGENCIA       = :IDAGENCIA,
                    IDCONTCORR      = :IDCONTCORR,
                    IDPRODUTOADQ    = :IDPRODUTOADQ,
                    IDADQUIRENTE    = :IDADQUIRENTE,
                    IDBANDEIRA      = :IDBANDEIRA,
                    IDAJUSTEAUT     = :IDAJUSTEAUT,
                    NRORDEM         = :NRORDEM,
                    NRDIASTOL       = :NRDIASTOL,
                    IDDTVENCIMENTO  = :IDDTVENCIMENTO
                WHERE NRADQUIRENTE  = :NRADQUIRENTE
                  AND NRESTABELEC   = :NRESTABELEC
                  AND NRVALIDACAOADQEST = :NRVALIDACAOADQEST";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertOrderStandarts($params){
        $sql = "INSERT INTO VALIDACAOADQ
                  (IDNSU, IDNSUPOS, IDTOLERANCIA, IDBANCO, IDAGENCIA, IDCONTCORR, IDPRODUTOADQ, 
                    IDADQUIRENTE, IDBANDEIRA, IDAJUSTEAUT, NRVALIDACAOADQ,  NRORDEM, NRDIASTOL, NRADQUIRENTE, IDDTVENCIMENTO) 
                VALUES
                  (:IDNSU, :IDNSUPOS, :IDTOLERANCIA, :IDBANCO, :IDAGENCIA, :IDCONTCORR, :IDPRODUTOADQ, 
                    :IDADQUIRENTE, :IDBANDEIRA, :IDAJUSTEAUT, :NRVALIDACAOADQ, :NRORDEM, :NRDIASTOL, :NRADQUIRENTE, :IDDTVENCIMENTO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertOrderStandartsEst($params){
        $sql = "INSERT INTO VALIDACAOADQEST
                  (IDNSU, IDNSUPOS, IDTOLERANCIA, IDBANCO, IDAGENCIA, IDCONTCORR, IDPRODUTOADQ, 
                    IDADQUIRENTE, IDBANDEIRA, IDAJUSTEAUT, NRVALIDACAOADQEST,  NRORDEM, NRDIASTOL, NRADQUIRENTE, NRESTABELEC, IDDTVENCIMENTO) 
                VALUES
                  (:IDNSU, :IDNSUPOS, :IDTOLERANCIA, :IDBANCO, :IDAGENCIA, :IDCONTCORR, :IDPRODUTOADQ, 
                    :IDADQUIRENTE, :IDBANDEIRA, :IDAJUSTEAUT, :NRVALIDACAOADQEST, :NRORDEM, :NRDIASTOL, :NRADQUIRENTE, :NRESTABELEC, :IDDTVENCIMENTO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearOrderStandarts($params){
        $sql = "DELETE FROM VALIDACAOADQ
                WHERE NRADQUIRENTE    = :NRADQUIRENTE
                AND   NRVALIDACAOADQ  = :NRVALIDACAOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearEstabelecStandarts($params){
        $sql = "DELETE FROM VALIDACAOADQEST
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                AND   NRESTABELEC  = :NRESTABELEC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function clearOrderStandartsEst($params){
        $sql = "DELETE FROM VALIDACAOADQEST
                WHERE NRADQUIRENTE    = :NRADQUIRENTE
                AND   NRVALIDACAOADQEST  = :NRVALIDACAOADQEST
                AND   NRESTABELEC  = :NRESTABELEC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}
