<?php

namespace WebServiceCall\Repository\DB;

// Classe dedicada à manipulação dos dados referentes às tabelas de Log e Controle de Acesso da Rotina.
class WebServiceLog extends ABaseRepo {
     /* 
     * Inseri os dados desse acesso ao WS na tabela de controle do sistema. Quando o WS é executado, a tabela CONTROLEACESWS deve
     * receber dois novos registros, uma linha com os dados da conexão quando o sistema buscou o relátorio de vendas e outra linha
     * com as informações de quando o sistema buscou o relatório de pagamentos.
     *
     * @param $reportID: qual tipo de acesso foi realizado: de relatório de vendas ('V') ou relatório de pagamentos ('P')
     */
    public function insertControleAcessoWS($idTipo, $accessDate, $responseDate) {
        // Gera o NRSEQUENCIAL para a operação de insert
        $nrSeq = $this->conn->getNextTableId('CONTROLEACESWS');

        // Inserir as informações de acesso.
        $params = array(
            ':NRSEQ' => intval($nrSeq),
            ':IDTIPO' => trim(strval($idTipo)),
            ':NRORG' => $this->conn->getNRORG(),
            ':ACCESS_DATE' => trim(strval($accessDate)),
            ':RESPONSE_DATE' => trim(strval($responseDate)),
        );
        
        $this->conn->executeQuery(self::INSERT_CONTROLE_ACESSO_WS, $params, [], true);
        $this->conn->commit();
        
        return (int)$nrSeq;
    }
    
    public function updateControleAcessoWS($nrEstabelec, $nrCtrlAcesWS) {
        $params = array(
            ":NRESTABELEC" => $nrEstabelec,
            ":NRCTRLACESWS" => $nrCtrlAcesWS,
        );
        
        return $this->conn->executeQuery(self::UPDATE_CONTROLE_ACESSO_WS, $params);
    }

    private const INSERT_CONTROLE_ACESSO_WS = "
         INSERT INTO CONTROLEACESWS 
                (NRCTRLACESWS, IDTIPO, DTRETORNADA, DTACESSO, NRORG) 
            VALUES
                (:NRSEQ, ':IDTIPO', TO_DATE(':RESPONSE_DATE','DD/MM/YYYY HH24:MI:SS'), TO_DATE(':ACCESS_DATE','DD/MM/YYYY HH24:MI:SS'), :NRORG)
    ";
    private const UPDATE_CONTROLE_ACESSO_WS = "UPDATE CONTROLEACESWS SET NRESTABELEC = :NRESTABELEC WHERE NRCTRLACESWS = :NRCTRLACESWS";

}